<?php

class CollabPayWooCommerceFields
{
    public function __construct()
    {
        // Display WooCommerce Product Custom Fields
        add_action('woocommerce_product_options_general_product_data', array($this, 'displayCustomFields'), 10, 3);

        //  Saves WooCommerce Product Custom Fields
        add_action( 'woocommerce_process_product_meta', array($this, 'saveCustomFields'), 10, 3);
    }

    public function displayCustomFields()
    {
        echo '<div class="product_custom_field">';

        //Custom Product Number Field
        woocommerce_wp_text_input(
            array(
                'id' => '_collabpay_cost',
                'placeholder' => '',
                'label' => __('CollabPay cost ('.get_woocommerce_currency_symbol().')', 'woocommerce'),
                'type' => 'number',
                'custom_attributes' => array(
                    'step' => '0.01',
                    'min' => '0'
                )
            )
        );

        echo '</div>';
    }

    public function saveCustomFields($post_id)
    {
        $value = isset($_POST['_collabpay_cost']) ? $_POST['_collabpay_cost'] : null;

        update_post_meta($post_id, '_collabpay_cost', esc_attr($value));
    }
}
