<?php
/*
    Plugin Name: CollabPay
    Plugin URI:  https://collabpay.app/wordpress-plugin
    Description: CollabPay webhook and rest API plugin
    Version:     1.1.0
    Author:      collabpay
    Author URI:  https://collabpay.app/
*/

if (! in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins')))) {
    deactivate_plugins(plugin_basename(__FILE__));
    wp_die(__('Please install and activate WooCommerce.', 'woocommerce-addon-slug'), 'Plugin dependency check', array('back_link' => true ));
}

require('includes/Collabpay.php');
require('includes/CollabpayWebhook.php');
require('includes/CollabpayRestApi.php');
require('includes/CollabpaySettingsPage.php');
require('includes/CollabPayWooCommerceFields.php');

register_deactivation_hook(__FILE__, function () {
    (new CollabpayWebhook())->delete();
    (new CollabpayRestApi())->delete();

    if ($key = get_option('collabpay_api_key')) {
        (new Collabpay())->deleteIntegration($key);
        delete_option('collabpay_api_key');
    }
});

add_filter('woocommerce_max_webhook_delivery_failures', function ($number) {
    // only try ten times, after this it'll be picked up by a
    // scheduled task to find any missing orders / products.

    return 10;
});

if (wp_get_environment_type() == 'local') {
    function allow_unsafe_urls($args)
    {
        $args['reject_unsafe_urls'] = false;
        return $args;
    }

    add_filter('http_request_args', 'allow_unsafe_urls');
    add_filter('https_ssl_verify', '__return_false');
}

(new CollabpaySettingsPage())->run();
(new CollabPayWooCommerceFields());
